summaryrefslogtreecommitdiffstats
path: root/contrib
diff options
context:
space:
mode:
authorAaron Griffin <aaron@archlinux.org>2007-02-26 10:19:33 +0100
committerAaron Griffin <aaron@archlinux.org>2007-02-26 10:19:33 +0100
commitf9a40e5d6ff09610098d1a52e133252bdee3166f (patch)
tree4d810ef24964e32b341ece542f827651f223ad75 /contrib
parent4dd6c9222879198eaff8da464d9eb0ecf6313954 (diff)
downloadpacman-f9a40e5d6ff09610098d1a52e133252bdee3166f.tar.gz
pacman-f9a40e5d6ff09610098d1a52e133252bdee3166f.tar.xz
* Added a small note to HACKING
* Moved re-pacman to contrib/ as it's probably not as useful as the other stuff in scripts/
Diffstat (limited to 'contrib')
-rwxr-xr-xcontrib/re-pacman79
1 files changed, 79 insertions, 0 deletions
diff --git a/contrib/re-pacman b/contrib/re-pacman
new file mode 100755
index 00000000..350fe865
--- /dev/null
+++ b/contrib/re-pacman
@@ -0,0 +1,79 @@
+#!/bin/sh
+#
+# re-pacman: regenerate a pacman package based on installed files and the
+# pacman database entries. Useful for reuse, or possible config file
+# extension
+#
+# Copyright (c) 2006 Aaron Griffin <aaron@archlinux.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
+# USA.
+#
+
+#TODO
+# * Check for md5 changes in backup lines and change pkgrel
+
+pacinfo () {
+ [ $# -ne 2 ] && return 1
+ #use echo to strip spaces
+ echo $(pacman -Qi ${1} | grep "${2}" | cut -d: -f2-)
+}
+
+make_pkginfo () {
+ echo "# Generated by re-pacman 1.0.0"
+ echo "# On $(date)"
+ echo "pkgname =$(pacinfo ${1} Name)"
+ echo "pkgver =$(pacinfo ${1} Version)"
+ echo "pkgdesc =$(pacinfo ${1} Description)"
+ echo "url =$(pacinfo ${1} URL)"
+ echo "builddate =$(pacinfo ${1} 'Build Date')"
+ echo "packager =$(pacinfo ${1} Packager)"
+ echo "size =$(pacinfo ${1} Size)"
+ echo "arch =$(pacinfo ${1} Architecture)"
+ deps=$(pacinfo ${1} 'Depends On')
+ for d in ${deps}; do
+ echo "depend = ${d}"
+ done
+}
+
+if [ $# -ne 1 ]; then
+ echo "usage: re-pacman <installed package name>"
+ exit 1
+fi
+
+ver=$(pacinfo ${1} Version)
+if [ "x${ver}" = "x" ]; then
+ echo "Package '${1}' not found, aborting."
+ exit 1
+fi
+
+echo ":: Cleaning up old files"
+rm -f .PKGINFO .FILELIST "${1}-${ver}.pkg.tar.gz"
+
+echo ":: Building PKGINFO"
+make_pkginfo ${1} > .PKGINFO
+echo ":: Building FILELIST"
+pacman -Ql ${1} | cut -d' ' -f2- > .FILELIST
+
+flist=".PKGINFO .FILELIST"
+flist="${flist} $(pacman -Ql ${1} | sed 's|\w* \(.*\)|/\1|g' | grep -v '/$')"
+
+echo ":: Building final package tarball"
+echo ${flist} | tr ' ' '\n' | tar czf "${1}-${ver}.pkg.tar.gz" -T - 2>/dev/null
+
+rm -f .PKGINFO .FILELIST
+echo ":: Package '${1}-${ver}.pkg.tar.gz' is now ready for installation"
+
+# vim: set ts=2 sw=2 noet: